"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.groupById = exports.setPathValue = exports.parseDates = void 0;
function parseDates(obj, paths) {
    let newObj = JSON.parse(JSON.stringify(obj));
    for (const path of paths) {
        const subpaths = path.split('.');
        setPathValue(newObj, [...subpaths], new Date(getPathValue(obj, [...subpaths])));
    }
    return newObj;
}
exports.parseDates = parseDates;
function getPathValue(obj, path) {
    const value = obj[path[0]];
    path.shift();
    if (!path.length || typeof value === 'undefined' || value === null)
        return value;
    return getPathValue(value, path);
}
function setPathValue(obj, path, value) {
    const subPath = path[0];
    if (path.length === 1 && subPath) {
        obj[subPath] = value;
        return obj;
    }
    path.shift();
    if (!obj[subPath]) {
        obj[subPath] = {};
    }
    return setPathValue(obj[subPath], path, value);
}
exports.setPathValue = setPathValue;
function groupById(arr) {
    return arr.reduce((acc, item) => (Object.assign(Object.assign({}, acc), { [item._id]: item })), {});
}
exports.groupById = groupById;
//# sourceMappingURL=helpers.js.map