"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.del = exports.patch = exports.put = exports.post = exports.get = void 0;
const node_fetch_1 = require("node-fetch");
const request = (method, endpoint, data, options = {}) => {
    const fetchOptions = { method };
    fetchOptions.headers = {};
    if (options.token) {
        fetchOptions.headers.Authorization = `JWT ${options.token}`;
    }
    let url = process.env.UWAVE_API_BASE_URL + endpoint;
    if (method === 'get' && data) {
        const querystring = querystringify(data);
        if (querystring) {
            url += `?${querystring}`;
        }
    }
    else if (data) {
        fetchOptions.headers['Content-Type'] = 'application/json';
        fetchOptions.body = JSON.stringify(data);
    }
    return node_fetch_1.default(url, fetchOptions).then((res) => res.json());
};
const querystringify = (obj = {}) => Object.entries(obj)
    .map((pair) => pair.map(encodeURIComponent).join('='))
    .join('&');
const get = (...args) => request('get', ...args);
exports.get = get;
const post = (...args) => request('post', ...args);
exports.post = post;
const put = (...args) => request('put', ...args);
exports.put = put;
const patch = (...args) => request('patch', ...args);
exports.patch = patch;
const del = (...args) => request('delete', ...args);
exports.del = del;
//# sourceMappingURL=http.js.map