import { uWave } from '..';
import { HistoryEntry, Playback, VOTE_DIRECTIONS } from '../types/entities';
import { PaginatedHistoryEntries } from '../types/domain';
export default class Booth {
    private uw;
    static VOTE_DIRECTIONS: typeof VOTE_DIRECTIONS;
    static HISTORY_ENTRY_DATE_FIELDS: string[];
    constructor(uw: uWave);
    getBooth(): Promise<HistoryEntry | null>;
    getHistory(media?: string, offset?: number, limit?: number): Promise<PaginatedHistoryEntries>;
    getVote(historyId: string): Promise<VOTE_DIRECTIONS>;
    vote(historyId: string, direction: VOTE_DIRECTIONS.UPVOTE | VOTE_DIRECTIONS.DOWNVOTE): Promise<null>;
    favorite(playlistID: string, historyID: string): Promise<{
        item: Playback;
        playlistSize: number;
    }>;
    skip(remove?: boolean): Promise<null>;
    skip(remove: boolean, userID: string, reason: string): Promise<null>;
    replaceBooth(userID: string): Promise<null>;
}
