import { SourceData } from './sources';
export declare type Media = {
    _id: string;
    duration: number;
    artist: string;
    title: string;
    thumbnail: string;
    sourceType: 'youtube' | 'soundcloud';
    sourceID: number | string;
    sourceData: SourceData;
    createdAt: Date;
    updatedAt: Date;
};
export declare type Playback = {
    start: number;
    end: number;
    title: string;
    artist: string;
    media: Media;
};
export declare type User = {
    _id: string;
    username: string;
    slug: string;
    avatar: string;
    roles: string[];
    role: number;
    level: number;
    language: string;
    exiled: boolean;
    activePlaylist?: string;
    lastSeenAt: Date;
    createdAt: Date;
    updatedAT: Date;
};
export declare type HistoryEntry = {
    historyID: string;
    playlistID: string;
    user: User;
    playedAt: Date;
    media: Playback;
    stats: {
        upvotes: number;
        downvotes: number;
        favorites: number;
    };
};
export declare enum VOTE_DIRECTIONS {
    UPVOTE = 1,
    DIDNT_VOTE = 0,
    DOWNVOTE = -1
}
